var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _typeof = typeof Symbol === "function" && typeof Symbol.iterator === "symbol" ? function (obj) { return typeof obj; } : function (obj) { return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; };

function _objectWithoutProperties(obj, keys) { var target = {}; for (var i in obj) { if (keys.indexOf(i) >= 0) continue; if (!Object.prototype.hasOwnProperty.call(obj, i)) continue; target[i] = obj[i]; } return target; }

import React from 'react';
import PropTypes from 'prop-types';
import classNames from 'classnames';
import { tagPropType, mapToCssModules } from './Shared/helper.js';
import CIconRaw from './CIconRaw';
import style from './CIcon.module.css';

//component - CoreUI / CIcon

var CIcon = function CIcon(props) {
  var Tag = props.tag,
      className = props.className,
      cssModule = props.cssModule,
      name = props.name,
      size = props.size,
      attributes = _objectWithoutProperties(props, ['tag', 'className', 'cssModule', 'name', 'size']);

  //render

  var type = 'svg';

  if ((typeof name === 'undefined' ? 'undefined' : _typeof(name)) == 'object') {
    switch (name.type) {
      case 'class':
        type = 'class';
        break;
      default:
    }
  }

  if (type == 'svg') {
    return React.createElement(CIconRaw, _extends({}, attributes, { name: name, size: size, className: className }));
  }

  var classes = classNames(mapToCssModules(className, Object.assign(style, cssModule)), type == 'name' ? name : type == 'class' ? name.className : null, size ? 'c-icon-' + size : null);

  return React.createElement(Tag, _extends({}, attributes, { className: classes }));
};

CIcon.propTypes = process.env.NODE_ENV !== "production" ? {
  className: PropTypes.string,
  cssModule: PropTypes.object,
  //
  name: PropTypes.oneOfType([PropTypes.object, PropTypes.string]),
  size: PropTypes.string
} : {};

CIcon.defaultProps = {
  tag: 'i'
};

export default CIcon;